Description

We are working on improving the OTS console display, and one feature that would be really nice to have would be the ability to
adjust TRACE levels from within the ots GUI environment. However, since we now use DAQInterface to manage artdagq, it is possible
for artdaq processes to run on hosts where there are no ots processes, and it would be most convenient to have the artdaq
processes manage their TRACE levels themselves in that case.

What | would like is a couple of functions in the rc.control.daginterface object which send trace_get and trace_set XMLRPC
commands to the artdaq processes, and collect the output and present it in some reasonable way in the returned string/object.

Related issues:
Related to artdaq - Bug #23824: An error results when trying to set an artdag... Closed 01/05/2020

Associated revisions

Revision e6daaa4b - 01/02/2020 04:16 PM - John Freeman
JCF: Issue #23792: add in skeleton of trace_get call

Revision 13a01adc - 01/02/2020 05:56 PM - John Freeman

JCF: Issue #23792: rudimentary, proof-of-concept implementation of trace_get call from DAQInterface

Revision 194e2b73 - 01/03/2020 10:19 AM - John Freeman

JCF: Issue #23792: wrap up implementation of trace_get, with trace_get.sh script provided

Revision 772¢6d8d - 01/03/2020 04:36 PM - John Freeman

JCF: Issue #23792: added support for trace_set with the assumption that artdaq's trace_set takes the mask in string form (see soon-to-be-filed
artdaq Issue)

Revision 930e425d - 01/05/2020 11:34 PM - John Freeman

JCF: Issue #23792: change order of trace_set arguments to masktype, name, mask rather than name, masktype, mask

Revision de08d2f6 - 01/06/2020 04:28 PM - John Freeman

JCF: Issue #23792: make sure the new trace_set argument order of name, type, mask appears everywhere + remove a couple of debug prints
Revision 1e43dbbe - 01/08/2020 01:12 PM - John Freeman
JCF: Issue #23792: make sure that after the prior commit DAQInterface continues to work with artdaq code which predates the changes from artdaq

Issue #23824

Revision c5b8f434 - 01/08/2020 01:30 PM - John Freeman

JCF: Issue #23792: print the date at the top of the file produced by trace_get so as to avoid confusion

History

#1 - 12/20/2019 03:32 PM - Eric Flumerfelt
- Category set to artdaq-daqinterface

#2 - 01/05/2020 11:39 PM - John Freeman
- % Done changed from 0 to 100

- Status changed from New to Resolved

05/04/2021 12




This issue is resolved with commit 930e425dc822fb70fd45e4b4f2405ff52eb5b64f at the head of feature/23792_trace_get_and_set. DAQInterface
now has functions "trace_get" and "trace_set" which calls the functions of the same name on the individual artdaq processes via XML-RPC. While
typically under otsdaq | believe a DAQInterface object has its functions called directly, it's also possible to call the DAQInterface trace_get and
trace_set functions via two scripts I've added. Surprise, they're named trace_set.sh and trace_get.sh.

One thing to be aware of is that these calls express the mask as a string, rather than an integer; for this reason you'll need to be using an artdaq
which includes the fix described in Issue #23824.

#3 - 01/06/2020 12:04 PM - Eric Flumerfelt

- Related to Bug #23824: An error results when trying to set an artdaq process's mask via xmlrpc added

#4 - 01/06/2020 12:07 PM - Eric Flumerfelt
- Assignee set to John Freeman

- Co-Assignees Eric Flumerfelt added

| have tested this functionality, and made a couple tweaks on the daqginterface branch, related to #23824. | think it's really interesting that python didn't
support the XMLRPC i8 data type until version 3.6, and it is still not clear if an actual 64-bit value will work properly from a python client.
daginterface|45f21274be52

#5 - 01/08/2020 01:34 PM - John Freeman

- Status changed from Resolved to Reviewed

At the head of feature/23792_trace_get_and_set, I've confirmed that trace_set and trace_get continue to work, and that the trace_set arguments are
in name, type, mask order everywhere. The artdaq version on which my tests were done was commit f{42d46947a03 on the
feature/23824_fix_trace_set branch. However, DAQInterface continues to work with artdaq versions which predate feature/23824_fix_trace_set and
thus expect the run number to be sent as a string rather than an int.

#6 - 11/30/2020 12:32 PM - Eric Flumerfelt

- Status changed from Reviewed to Closed
